import java.util.Hashtable;
import java.util.Enumeration;
import java.util.Set;

public class Main {
    public static void main(String[] args) {
        // Hashtable creation
        Hashtable<String, String> skNeighbors = new Hashtable<>();

        // Adding country codes and country names
        skNeighbors.put("SK", "Slovakia");
        skNeighbors.put("CZ", "Czech Republic");
        skNeighbors.put("AT", "Austria");
        skNeighbors.put("HU", "Hungary");
        skNeighbors.put("UA", "Ukraine");
        skNeighbors.put("PL", "Poland");

        // Display all country codes and names using Enumeration
        System.out.println("Neighboring states of Slovakia:");
        Enumeration<String> keys = skNeighbors.keys();
        while (keys.hasMoreElements()) {
            String code = keys.nextElement();
            if(!code.equals("SK"))
                System.out.println(code + " - " + skNeighbors.get(code));
        }

        // Lookup a country by its code
        String searchCode = "DE";
        if (skNeighbors.containsKey(searchCode)) {
            System.out.println("\n✅ Country found for code " + searchCode + ": " + skNeighbors.get(searchCode));
        } else {
            System.out.println("\n❌ No country found for code " + searchCode);
        }

        // Display the total number of countries in the directory
        System.out.println("\nTotal number of countries in the Hashtable (before remove): " + skNeighbors.size());

        // Try to remove a country by its code which is not present
        String removeCode = "DE";
        String removedCountry = skNeighbors.remove(removeCode);
        System.out.println("Removed country: " + removeCode + " - " + removedCountry);

        // Try to remove a country by its code
        removeCode = "SK";
        removedCountry = skNeighbors.remove(removeCode);
        System.out.println("Removed country: " + removeCode + " -> " + removedCountry);

        // Check if a specific country exists in the table
        String searchCountry = "Germany";
        if (skNeighbors.containsValue(searchCountry)) {
            System.out.println("✅ " + searchCountry + " is in the directory.");
        } else {
            System.out.println("❌ " + searchCountry + " is NOT in the directory.");
        }

        // Display the total number of countries in the directory
        System.out.println("\nTotal number of countries in the Hashtable (after remove): " + skNeighbors.size());

        // Clear all country entries
        skNeighbors.clear();
        System.out.println("Country directory cleared. Is it empty? " + skNeighbors.isEmpty());

        // Display all remaining countries using keySet()
        System.out.println("Remaining countries after clearing:");
        Set<String> keySet = skNeighbors.keySet();
        for (String code : keySet) {
            System.out.println(code + " - " + skNeighbors.get(code));
        }
    }
}